#!/usr/bin/perl -w
#
# read_calls.pl
# 
# Synopsis:
# Script is run as a service daemon. It connects to the Fritz!Box Fon Ata
# (port 1012) and receives the calling string (number of the party calling 
# in). This number is passed on to another program. I.e. this could be an 
# Jabber client or a "look who called list".
# 
# Requirements:
# - must be able to reach tcp port 1012 on your FB
# - activate call monitor on FB by dialing #96*5*
# - required perl package
#
# Licence: GPL2
#
# History:
# ver. 0.1 - 20060401 - Lars G. Sander, Zuerich
# First public release.
# ver. 0.2 - 20060510 - Ulrich Dangel <fritzbox@spamt.net>
# Added telefon book support
# To Do:
# - beefed up security?
# - proxy functionality
# - additionally monitor calls OUT

use IO::Socket;
use strict;

# --------- PLEASE SET YOUR PREFERENCES ---------#

# your fritz box (ip or hostname)
my $FRITZBOX="fritz.box";
my $TELEFONBUCH="$ENV{HOME}/.xbmc/scripts/addressbook";
#my $PIC="$ENV{HOME}/.xbmc/scripts/";
my $PIC="/media/cover/phoneicons/";

# your XBMC HTTP-Server, Port, User and Password
my $HTTP_SERVER="localhost:80";
my $HTTP_USER="xbmc";
my $HTTP_PASSWD="xbmcpw";

#-------- NO USER SERVICABLE PARTS BELOW -------#

sub read_book {
    my %book = ();
    open(IN, "<", $TELEFONBUCH) || return ();
    while(<IN>){
        chomp;
        my @elements = split(":",$_);
        $book{$elements[0]}=$elements[1];
    }
    close(IN);
    return %book;
}


my %book = &read_book;

my $sock = new IO::Socket::INET (
        PeerAddr => $FRITZBOX,
        PeerPort => '1012',
        Proto => 'tcp'
        );
        die "Could not create socket: $!\n" unless $sock;
    
while(<$sock>) {
        if ($_ =~ /RING/){
                my @C = split(/;/);
                my $nr="";
								my $icon=$PIC . '000.png';
								my $picture="";

                if (exists($book{$C[3]})) {
                    $nr=$book{$C[3]};

										$picture = $PIC . $C[3] . '.jpg';
										if (-e $picture) {
											$icon = $picture;
										}
                } else {
                    $nr=$C[3];
										if ($nr ne "") {
											open(OUT, ">>", $TELEFONBUCH);
											print OUT $nr . ':' . $nr . "\n";
											close(OUT);
											%book = &read_book;
										}
                }
                my @arg_pause = ("/usr/bin/wget --http-user=$HTTP_USER --http-passwd=$HTTP_PASSWD --spider 'http://$HTTP_SERVER/xbmcCmds/xbmcHttp?command=Pause()'");
                my @arg_callin = ("/usr/bin/wget --http-user=$HTTP_USER --http-passwd=$HTTP_PASSWD --spider 'http://$HTTP_SERVER/xbmcCmds/xbmcHttp?command=ExecBuiltIn&parameter=XBMC.Notification(Telefon,Anruf von $nr,5000,$icon)'");
                # system(@arg_pause);
                system(@arg_callin); 
        }
        if ($_ =~ /DISCONNECT/){
                my @arg_pause = ("/usr/bin/wget --http-user=$HTTP_USER --http-passwd=$HTTP_PASSWD --spider 'http://$HTTP_SERVER/xbmcCmds/xbmcHttp?command=Pause()'");
                my @arg_callend = ("/usr/bin/wget --http-user=$HTTP_USER --http-passwd=$HTTP_PASSWD --spider 'http://$HTTP_SERVER/xbmcCmds/xbmcHttp?command=ExecBuiltIn&parameter=XBMC.Notification(Telefon,Anruf beendet)'");
                # system(@arg_pause);
                system(@arg_callend);
        }
}
